package repo

import (
	"egg-im/internal/logic/domain/group/model"
	"egg-im/pkg/db"
	"egg-im/pkg/gerrors"

	"github.com/jinzhu/gorm"
)

type groupNoticeWithLikeRecords struct{}

var GroupNoticeWithLikeRecordsDao = new(groupNoticeWithLikeRecords)

// Get 获取用户点赞信息
func (*groupNoticeWithLikeRecords) Get(userId, groupId int64) (*model.GroupNoticeWithLikeRecords, error) {
	group := model.GroupNoticeWithLikeRecords{}
	err := db.DB.First(&group, "user_id = ? and group_id = ?", userId, groupId).Error
	if err != nil && err != gorm.ErrRecordNotFound {
		return nil, err
	}
	if err == gorm.ErrRecordNotFound {
		return nil, nil
	}
	return &group, nil
}

// Save 插入一条群组
func (*groupNoticeWithLikeRecords) Save(groupNoticeWithLikeRecords *model.GroupNoticeWithLikeRecords) error {
	err := db.DB.Save(&groupNoticeWithLikeRecords).Error
	if err != nil {
		return gerrors.WrapError(err)
	}
	return nil
}

// Delete 取消点赞
func (*groupNoticeWithLikeRecords) Delete(userId, groupId int64) (err error) {
	group := model.GroupNoticeWithLikeRecords{}
	err = gerrors.WrapError(db.DB.Where("user_id = ? and group_id = ?", userId, groupId).Delete(&group).Error)
	if err != nil {
		return err
	}
	return nil
}

// Clean 清除群组点赞记录
func (*groupNoticeWithLikeRecords) Clean(groupId int64) (err error) {
	group := model.GroupNoticeWithLikeRecords{}
	err = gerrors.WrapError(db.DB.Where("group_id = ?", groupId).Delete(&group).Error)
	if err != nil {
		return err
	}
	return nil
}
